export declare class ConvertPlusUrlGeneratorError extends Error {
}
export declare class RequiredForDynamicProductsError extends Error {
    constructor(field: string);
}
declare abstract class BaseConvertPlusUrlGenerator {
    email?: string;
    name?: string;
    phone?: string;
    country?: string;
    state?: string;
    address?: string;
    address2?: string;
    zip?: string;
    shipName?: string;
    shipCountry?: string;
    shipState?: string;
    shipAddress?: string;
    shipAddress2?: string;
    shipZip?: string;
    dynamic: boolean;
    prod: string[];
    itemExtRef?: string;
    type?: "product" | "shipping" | "tax";
    qty: number[];
    price?: ({
        [key: string]: number;
    } | number)[];
    tangible?: boolean;
    opt?: string;
    description?: string;
    recurrence?: {
        DAY?: number;
        WEEK?: number;
        MONTH?: number;
        YEAR?: number;
        FOREVER?: number;
    }[];
    duration?: string;
    renewalPrice?: string;
    merchant: string;
    subscription?: string;
    expiration?: number;
    returnUrl?: string;
    returnType?: "Link" | "Redirect";
    coupon?: string[];
    src?: string;
    tpl?: "default" | "one-column" | string;
    currency?: string;
    emptyCart?: boolean;
    orderExtRef?: string;
    language?: string;
    originUrl?: string;
    style?: string;
    test?: boolean;
    customerRef?: string;
    customerExtRef?: string;
    lock?: boolean;
}
export declare class ConvertPlusUrlGenerator extends BaseConvertPlusUrlGenerator {
    merchant: string;
    secret_word: string;
    constructor(merchant: string, secret_word: string, data: BaseConvertPlusUrlGenerator);
    getUrl(): string;
    /**
     * Get parameters for url in right form
     */
    getParameters(): {
        [key: string]: string;
    };
    private getPrice;
    private getRecurrence;
    private getSignature;
}
export {};
